// $Id: series_factory_script.cxx 3546 2005-04-03 08:30:29Z jz $
/*
    Hier sind implementiert

    Script
    Script_instance
*/


#include "precomp.h"
#include "../kram/sos.h"

#if 0



#include <objbase.h>        // OLE
#include "../msscript.h"    // GUID fr Scripting Engine
#include <activscp.h>       // Scripting Engine

#include "series_factory_script.h"

using namespace std;

namespace sos {
namespace factory {

//-------------------------------------------------------------------------------------check_result
/*
bool check_result( const Variant& vt )
{
    if( vt.vt == VT_EMPTY    )  return true;                       // Keine Rckgabe? True, also weiter machen
    if( vt.vt == VT_NULL     )  return false;                      // NULL? False
    if( vt.vt == VT_DISPATCH )  return vt.pdispVal != NULL;        // Nothing => False, also Ende
    if( vt.vt == VT_BOOL     )  return V_BOOL(vt) != 0;            // Nothing => False, also Ende

    Variant v = vt;

    HRESULT hr = v.ChangeType( VT_BOOL );
    if( FAILED(hr) )  throw_ole( hr, "VariantChangeType" );
    return V_BOOL(vt) != 0;
}
*/
//----------------------------------------------------------------------------Script_instance::init

void Script_instance::init( const string& language )
{
    _script_site = new Script_site;
    _script_site->_engine_name = language;
    _script_site->init_engine();
}

//----------------------------------------------------------------------------Script_instance::load
/*                                                                                                                                             
void Script_instance::add_obj( const ptr<IDispatch>& object, const string& name )
{
    Bstr name_bstr;
    name_bstr.Attach( SysAllocString_string( name ) );

    _script_site->add_obj( object, name_bstr );
}
*/
//--------------------------------------------------------------------Script_instance::set_language

void Script_instance::set_language( const string& language )
{
    if( !_script_site )  init( language );
                   else  if( _script_site->_engine_name != language )  throw_xc( "SPOOLER-117" );

}

//----------------------------------------------------------------------------Script_instance::load

void Script_instance::load( const string& script_text )
{
    if( !_script_site )  init( detect_script_language( script_text ) );

    _script_site->parse( script_text );

    _loaded = true;
}

//---------------------------------------------------------------------------Script_instance::close

void Script_instance::close()
{
    if( _script_site )
    {
        //try
        //{
            call_if_exists( "series_factory_exit" );
        //}
        //catch( const Xc& x ) { _log->error( x.what() ); }

        _script_site->close_engine();
        _script_site = NULL;
    }

    _loaded = false;
}

//------------------------------------------------------------------Script_instance::call_if_exists

Variant Script_instance::call_if_exists( const char* name )
{
    return name_exists( name )? call( name ) 
                              : Variant();
}

//------------------------------------------------------------------Script_instance::call_if_exists

Variant Script_instance::call_if_exists( const char* name, const Variant& param )
{
    return name_exists( name )? call( name, param ) 
                              : Variant();
}

//------------------------------------------------------------------Script_instance::call_if_exists

Variant Script_instance::call_if_exists( const char* name, Variant* param )
{
    return name_exists( name )? call( name, param ) 
                              : Variant();
}

//----------------------------------------------------------------------------Script_instance::call

Variant Script_instance::call( const char* name )
{
    return _script_site->call( name );
}

//----------------------------------------------------------------------------Script_instance::call

Variant Script_instance::call( const char* name, const Variant& param )
{
    return _script_site->call( name, param );
}

//----------------------------------------------------------------------------Script_instance::call

Variant Script_instance::call( const char* name, Variant* param )
{
    return _script_site->call( name, param );
}

//--------------------------------------------------------------------Script_instance::property_get
/*
Variant Script_instance::property_get( const char* name )
{
    return _script_site->property_get( name );
}
*/
//-------------------------------------------------------------------------------------------------

} //namespace factory
} //namespace sos


#endif