// $Id: filename.h 3546 2005-04-03 08:30:29Z jz $

#ifndef __ZSCHIMMER_FILENAME_H
#define __ZSCHIMMER_FILENAME_H


namespace zschimmer {

//-----------------------------------------------------------------------------------------Filename

struct Filename : string
{
                                Filename                    ( const string& path = "" )             : string(path) {}

    Filename&                   operator =                  ( const string& path )                  { *static_cast<string*>( this ) = path;  return *this; }

    Filename                    directory                   () const;
    string                      extension                   () const;
    string                      basename                    () const;
    const string&               path                        () const                                { return *static_cast<const string*>( this ); }
    string                      absolute_path               () const;
};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
